//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link      "http://www.metaquotes.net"


//---Declaration--Flag Setting--- for Activation/Deactivation of pairs -----

//========================================
// Constant Declarations
//========================================    

#define   NO_ENTRY      0    // I have declared some 'manifest constants' that will be useful for the entry rules. They are simply 'Word' substitutes
#define 	 LONG_ENTRY    1    // for the specified numbers.  They  make the program more readable.
#define   SHORT_ENTRY  -1    // Note that I have used all capital letters  for these constants to differentiate them from other other variables
#define   NUM_CURRENCY_PAIRS 5      

                       
//+--------------------------------------------------------+
//|         EXTERNAL PARAMETERS                            |
//| can be set or adjusted by user in properties window    |
//+--------------------------------------------------------+ 
   
     extern bool      EUR_USD_BuyFlag   = true;    //Set to true to allow long trading for this currency pair
     extern bool      EUR_USD_SellFlag = true;     //Set to true to allow short trading for this currency pair
     extern double    EUR_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for EURUSD
     extern double    EUR_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis EURUSD
     
     extern bool      GBP_USD_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      GBP_USD_SellFlag =  true;    //true = active, false= deactivated for trading
     extern double    GBP_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for GBPUSD
     extern double    GBP_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis GBPUSD
         
     extern bool      USD_JPY_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      USD_JPY_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_JPY_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDJPY
     extern double    USD_JPY_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDJPY
      
     extern bool      USD_CHF_BuyFlag   = true;    //true = active, false= deactivated for trading
     extern bool      USD_CHF_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_CHF_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDCHF
     extern double    USD_CHF_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDCHF
      
     extern bool      AUD_USD_BuyFlag   = true;     //true = active, false= deactivated for trading
     extern bool      AUD_USD_SellFlag  = true;     //true = active, false= deactivated for trading
     extern double    AUD_USD_TopFilter_Ok;         //Set the value of TopFilterLevel manually on a daily basis for AUDUSD
     extern double    AUD_USD_BotFilter_Ok;         //Set the value of BottomFilterLevel manually on a daily basis for AUDUSD

     extern double LotSize = 0.01 ;   // The default value is set to 0.01. The user can change it to whatever is required in the properties window.
     extern bool DEBUG_ON = true;     // This turns on the debug comments for testing and problem solving
     extern int TakeProfit = 20;      // TakeProfit Stop In pips.
  
   

//+------------------------------------------------------------------+
//| Global Parameters                                                |
//| These values can be read or changed from anywhere in this        |
//| program but not by the user from the properties box              |
//+------------------------------------------------------------------+


   string CurrencyPair[NUM_CURRENCY_PAIRS] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"};  // Much the same thing as above but
                                                                                              // perhaps a bit more readable.
                                                               

  
   double TopFilters[NUM_CURRENCY_PAIRS];     // So we just define uninitialised arrays of the required size
   double BotFilters[NUM_CURRENCY_PAIRS];    // This is Step 1/2 for array building. Step 2/2 is to assign a numerical value to each element, we do this below
   bool   Buy_Flags[NUM_CURRENCY_PAIRS];
   bool   Sell_Flags[NUM_CURRENCY_PAIRS];  


//+------------------------------------------------------------------+
//|                 INIT function                                    |
//| Expert initialization function                                   | 
//| This function is called once when the EA is attached to a chart  |
//| It can be used to initialise parameters etc                      |      
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//----
    if (DEBUG_ON)
      Print("*** Debug *** init()");

//---------------Declaring Arrays---------------
 
 
   // To the best of my knowledge this is the only way we can assign static external variable values to an array in MT4                                                
   TopFilters[0]  =  EUR_USD_TopFilter_Ok;
   TopFilters[1]  =  GBP_USD_TopFilter_Ok;
   TopFilters[2]  =  USD_JPY_TopFilter_Ok;
   TopFilters[3]  =  USD_CHF_TopFilter_Ok;
   TopFilters[4]  =  AUD_USD_TopFilter_Ok;
   
   BotFilters[0]  =  EUR_USD_BotFilter_Ok;
   BotFilters[1]  =  GBP_USD_BotFilter_Ok;
   BotFilters[2]  =  USD_JPY_BotFilter_Ok;
   BotFilters[3]  =  USD_CHF_BotFilter_Ok;
   BotFilters[4]  =  AUD_USD_BotFilter_Ok;
   
   Buy_Flags[0]   =  EUR_USD_BuyFlag;
   Buy_Flags[1]   =  GBP_USD_BuyFlag;
   Buy_Flags[2]   =  USD_JPY_BuyFlag;
   Buy_Flags[3]   =  USD_CHF_BuyFlag;
   Buy_Flags[4]   =  AUD_USD_BuyFlag;
   
   Sell_Flags[0]  =  EUR_USD_SellFlag;
   Sell_Flags[1]  =  GBP_USD_SellFlag;
   Sell_Flags[2]  =  USD_JPY_SellFlag;
   Sell_Flags[3]  =  USD_CHF_SellFlag;
   Sell_Flags[4]  =  AUD_USD_SellFlag;
                                                 
                                                   
//----------------------------------------------------------
   return(0);
  } // End of INIT function
  
  
//+------------------------------------------------------------------+
//|                 DEINIT function                                  |
//| Expert deinitialization function                                 | 
//| This function is called once when the EA is deleted from a chart |
//| It can be used to do clean ups such as closing files etc.        |      
//| It is often unused.                                              |
//+------------------------------------------------------------------+

int deinit()
  {
//--------------------------------

//--------------------------------
   if (DEBUG_ON)
      Print("*** Debug *** deinit()");
 //----     
   
   return(0);
  } // End of DEINIT function
  

//+------------------------------------------------------------------+
//|                 START function                                   |
//| This is the main function that is called each 'tick' providing   |
//| the program isn't already busy. As this function is called,      |
//| typically  many times a minute we need to be carefull with what  |
//| we do here. It is quite easy to use up a lot of                  |
//| computer resources if we are not carefull.                       | 
//|                                                                  |
//+------------------------------------------------------------------+

int start()                  //note to me: use small letters for local variables and use those as much as possible; declare those at top of program so can be accessed by any function within prog
  {
    string currencySymbol;       
    double topFilter;     // ***topFilters (and other local variables names) have been changed from plural to singular for clarity of logic. The local variable holds
                          // only one value at any given point in time. The array holds the filters (plural) This is only to make the code more logically readable.
    double botFilter;    
    int  entryStatus;
    bool buyFlag;
    bool sellFlag;
                      
   // for (int c=0;c<count;c++)                   //loop started to go through each element of the Array. #2# Question
   // replace the local variable count with either a global variable  or the manifest constant NUM_CURRENCY_PAIRS
   // I suggest using the manifest constant approach because it is simpler and all that is required in this case. See other notes
    
    for (int c=0;c<NUM_CURRENCY_PAIRS;c++) 
    {
        currencySymbol = CurrencyPair[c]; //*** For each iteration of this block we extract one currency pair from the array and assign it to the local variable 
        buyFlag  = Buy_Flags[c];          //*** named currencySymbol. Note that I have also changed the global array name Pair to CurrencyPair for what I thought was better readability.  
        sellFlag = Sell_Flags[c];         //*** Note that I have also changed the global array name Pair to CurrencyPair for what I thought was better readability.  
        topFilter = TopFilters[c];
        botFilter = BotFilters[c];   
  
    //**** TO DO 23 Jun 09
    //*** Put the entry rules function call (below) into this bracketed block
    //*** Use the local variables above as parameters to the function
   
   
    // Eventually we will also put the code here for
    // 1.  checking for open orders. Hmm maybe you could write another function to do this
    // 2.  opening a new order if required by the netry rules
    // We want to process everything in this block for each currency pair in turn
    // That includes our debug code below.
  
  
           
        if (DEBUG_ON)
           // if (entryStatus != 0) 
            Print("*** Debug *** start() function.",
                  "   currencySymbol : ", currencySymbol,
                  "   topFilter : ", topFilter,
                  "   botFilter : ", botFilter,
                  "   buyFlag : ", buyFlag,
                  "   sellFlag : ", sellFlag,
                  "   entryStatus : ", entryStatus);
                                             
        
   }  // end of for loop for each currency pair
  
//-------------------------Declaring EMA's so we can use them in EntryRules function 

  
   //  entryStatus = EntryRules(); //*** TODO Pass this function some parameters between the brackets;
                                    //*** Make sure that the parameters are also declared in the code for the function.
                                    //**TIM: I don't understand this bit. We can't just put the 3 names into the brackets, can we? Why would we do that?

//  **** Yes we can just put the 3 names into the brackets provided they are defined in the actual function itself
//  **** for example  entryStatus = EntryRules(currencySymbol, topFilter,botFilter)

//  **** Nick When you call OrderSend(symbol(),OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green) you are calling a predefined function. You pass parameters to the
// function which tells it what to do. The function does "its thing"and often it returns a value. In the case of the OrderSend() function it will return a ticket number 
// if the function call is succesfull. If the function call is not succesfull it will return  a negative number telling you what sort of error has occured.
// i.e
//   ticketNumber = OrderSend(symbol(),OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green)
//   if (ticketNumber < 0)  
//        An Error has occured
 
//
// What we are doing with EntryRules is creating our own function which will check our entry rules for any given currency pair and return a Buy, Sell, or NoEntry result
// We will want to pass our EntryRules function parameters for currency pair, top filter and bottom filter. It will then, hopefully return us a one of three values
// i.e  LONG_ENTRY, SHORT_ENTRY, NO_ENTRY 



// *** Nick can we just skip all the rest of this stuff for the time being until we get the EntryRules function sorted out?
// *** It should all become a bit clearer then 

//--------------------------Check to see if  there is already  an open  BUY  position for this Currency Pair
//
 
  /*
   int CountBuys()           
      {
       int buys = 0;       //***TIM: This is the only way I know how to do something like this, and I don't even know how to do this really. Help.
       for (int i=0;i<OrdersTotal();i++)
         {
          if (OrderType(symbol)==OP_BUY)buys[symbol]++
       //I know this is totally wrong, can't figure it out.
       }
//----------------------------------------------------------------------------------------------------------+
       
    if (buys[symbol]=0 && buyflags =1 && EntryRules = LONG_ENTRY)
     {
      OrderSend(symbol(),OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green)    //Check the Entry Rules block  to see if a BUY or SELL  condition exists for the allowed Currency Pairs 
     }
     
    if (sells[symbol]=0 && sellflags=1 && EntryRules = SHORT_ENTRY)
     {
      OrderSend(symbol(),OP_SELL,Lots,Bid,0,0,Ask+TakeProfit*Point,"Sell",002,0,Red)
      }
    */  
        //*** We now call the EntryRules fuction which at the moment is just an empty shell with some coments in it
        //*** We are going to pass some parameters to this function and  get it to return to us  one of three
        //*** possible values NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY       
       
       
        //If    there is no open BUY position  for this currency pair   AND
        //      a BUY condition exixts for this currency pair           AND
        //      the BuyFlag is set true for this currency pair
        //      THEN   
        //          Open a BUY Position  for this currency pair
	     //          USING  Last Ask Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount

        //If    there is no open SELL position  for this currency pair   AND
        //      a SELL condition exixts for this currency pair           AND
        //      the SellFlag is set true for this currency pair
        //      THEN   
        //          Open a SELL Position  for this currency pair
	     //          USING  Last Bid Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount

        //*** Finally I have updated our debug statement so that we can have a look and see what is happening
     //   if (DEBUG_ON)
     //       Print("*** Debug *** start() function",
     //             "   currencySymbol : ", currencySymbol,
      //            "   entryStatus : ", entryStatus);
  //
   

     

  } // End of START function
  
  

               //+-------------------------------------------------------------------+
               //|                 ENTRY RULES  function                             |
               //| See if a BUY or SELL condition exists for a specified             |
               //| currency pair                                                     |
               //|                                                                   |
               //+-------------------------------------------------------------------+
 

 //*** HAS BEEN DONE - The code for this function                    
//int EntryRules() // Parameter declarations for the function go between the brackets()
                   // Parameters are declared the same way as variables. Multiple parameters should be separated by commas. 
                   // for example - int MyFunction(string MyText, int MyNumber, bool MyFlag)

int EntryRules(string CurrencySym, double TopFilter, double BottomFilter)  

          //***TIM: So in brackets we only put global variables, because we call these to use with this function. Right?
          //Answer. The variables in the brackets belong to the function. They are function parameters but are defined in the same was as ordinary
          //        program variables. They are used to pass specific values, which may be and often are in the form of other variables to the function.
          //        The function like wise returns an integer value (int) in the return statement. If a function doesn't return any value it is declared as
          //        type void    i.e void EntryRules()  A function declared like this requires no parameters and  returns no result.
          //
          //        Now you may well ask. What would be the use of such a function?
          //
          //        Well a function im MT4 can directly read values from global variables and directly write to or change the values in global variables.
          //        BUT... We need to be very carefull doing this as we can quickly turn our nicely structured code into mush. MT4 is a fairly simple language
          //        as far as structure is concerned and sometimes, directly accessing global variables from within a function can not be avoided. MT5 may change this 
          //        but probably at a cost of making MT5 more difficult for newbies to use and learn.
          //   
          //        topFilterOk and botFilterOk are no longer defined as local variables. I commented them out for you :). Instead we access the parameters passed
          //        to the function i.e TopFilter * BottomFilter 
          //
          //        One final point. It is considered good practice to only exit the function at one point at its end. That means having only one return statement
          //        Again this can sometimes be impractical to achieve but it is quite easily accomplished in this case by simply introducing another 
          //        local variable which I have called result. 
          //     
          //        Also please note that I changed the function parameter name CurrencySymbol to CurrencySym buecause we have currencySymbol defined as a local 
          //        variable in the main start routine. While this is perfectly "legal" I thought that the similar names might confuse you.
          //
          //        
{

// Local variable declarations go here! 
    double emas_Up, emas_Down, topfilterok,botfilterok;    // I suggest the use of Upper case and or hyphens to make variable names more readable
  //  double topFilterOk,botFilterOk;   // You wont need these. Just use the parameter variables passed to the Entry Rules function 
  //****I don't see how we can do it without these Tim.
  //OK I will now show you now
    double ema7;    
    double ema14;
    double sma50;
    int result = NO_ENTRY;  // define a local integer (int) variable to return as the result. Assign it the default value of NO_ENTRY
                   
      ema7=iMA(CurrencySym,PERIOD_M5,7,MODE_EMA,Close,0);   
      ema14=iMA(CurrencySym,PERIOD_M5,14,MODE_EMA,Close,0);
      sma50=iMA(CurrencySym,PERIOD_M5,50,MODE_SMA,Close,0)  
   

      //If   the 7 Period Exponential Moving Average is greater than the 14 Period Exponential Moving Average    AND
      //     the 14 Period Exponential Moving Average is greater than the  50 period Simple Moving Average       AND
      //     Current Price   is less than TopFilterLevel  
      //     THEN
      //          Signal a  BUY (Long) entry condition
		
      emas_Up    =  ema7>ema14 && ema14>sma50;
      if (emas_Up && Ask < TopFilter) // Note the TopFilter value  is a parameter passed to the function just like CurrencySymbol. These have not been defined anywhere as global variables.
         result = LONG_ENTRY;   // We have assigned the manifest constant to the local variable result 
         
         
         
      
      //If   the  7 Period Exponential Moving Average is less than 14 Period Exponential Moving Average 
      //     the 14 Period Exponential Moving Average is less than the 50 period Simple Moving Average     
      //     Current Price   is more than  BottomFilterLevel  THEN
      //     THEN
      //          Signal a  SELL (Short) entry condition
      emas_Down  =  ema7<ema14 && ema14<sma50;
      if (emas_Down &&  Bid > BottomFilter)
         result = SHORT_ENTRY;   



      // At the end of all our "doing stuff" we put our expanded debug statement so that we can look in the log file and see what is going on 
      // I like to lay the print statement out in this way to make it easier to read and change.
      
      if (DEBUG_ON)
       // if (1==2)  If I uncomment this line it will turn off this particular debug statement.
       // Sometimes you can get too much information in the log file 
       //    if (result != NO_ENTRY)  // If I uncomment this line it will only display when there is a short or long entry signal
              Print("*** Debug *** EntryRules() function.",
                    "   CurrencySyb : ", CurrencySym,
                    "   ema7 : ", ema7,
                    "   ema14 : ",ema14,
                    "   sma50 : ", sma50,
                    "   TopFilter :", TopFilter,
                    "   Ask : ", Ask, 
                    "   BottomFilter :",BottomFilter,
                    "   Bid : ", Bid,
                    "   result : ", result);
               
       
       // And Finally
       //  return(0);   //*** Initially we assigned a return value of 0 just to allow the program to compile.
       return(result);  //*** Now we return a local variable which has been assigned a value of  NO_ENTRY, LONG_ENTRY or SHORT_ENTRY depending on the
                        //*** above logic
      
                 
 }  // End of Entry Rules function
 
 
     /*
      
     //***Old code from EntryRules function commented out so you can compare it with modified code if you want to
       emas_Up    =  ema7>ema14 && ema14>sma50;
       emas_Down  =  ema7<ema14 && ema14<sma50;
   
       topfilterok = Ask < topFilter;
       botfilterok= Bid > botfilters;
    
      if (emas_Up && topfilterok)
      {
          return(1)                     // 1= Long Entry, 0=No Entry, -1= Short Entry
      }
      if (emas_Down && botfilterok)
      }
         return(-1)
      {
    */              

                        

   


 
   
//------If (works) = celebrate !--------------------------------------------- 
   

//------------------------------------------------------------------------------------------------------------+
//                                                                                                            +
//                       List of Actions & Questions done by Nick 21 June 09                                  +
//                                                                                                            +
//------------------------------------------------------------------------------------------------------------+
//
// 0. Re-organised comments within the code to make it easier to follow (moved things into archive of comments at end)
// 1. Moved CurrencyPair array into init function (I assume that was better than it being outside of init, because you suggested other arrays to move into 
// 2. Created an Array for Flags and Filters in init function,
// Q: Why don't we say in the [] next to the array name the number of variables involved (eg: 5, etc)? Isn't that what its for?
// 3. Tried to set a global parameter next to the array sizing, called NumCurrencyPairs. Don't know what you mean by this Tim or how it's done? Help.
// TQ:*** A thought! Would a manifest constant for the number of currency pairs simplify things a bit? A: I'm planning to expand the strategy to more pairs shortly after I gather enough test data on it. So let's keep it as it is to simply things for me.
// 4. Search for #2# Question: Do we need to use the for count function for each array, or is there a different way to do it Tim? I still don't know how to implement this.
// 5. Created local variables sellflags, buyflags, topfilters, botfilters,
// TQ: #3#
// TQ: #4#
// 6. Working on int EntryRules function. Had to start by declaring ema's on a more global level so they call up the arrays.
// 7. Working on CountBuys condition, couldn't figure it out.
// 8. Working on OrderSend and what it's dependent on, I think I got about 80% of it. Please do check.


//------------------------------------------------------------------------------------------------------------+
//                                                                                                            +
//                       Answers to questions 22 June 09                                                      +
//                                                                                                            +
//------------------------------------------------------------------------------------------------------------+
//Q1: Why don't we say in the [] next .....
//A. The simple way to declare an array is as you suggest  ie CurrencyPair[5]. This is a STATIC ARRAY that will hold the same number of elements
//   throughout the running of the program. We could then replace the number 5 with a manifest constant #define NUM_CURRENCY_PAIRS 5 
//   and then define the array CurrencyPair[NUM_CURRENCY_PAIRS]. 
//   You would also define the other arrays the same way i.e TopFilters[NUM_CURRENCY_PAIRS].
//   When the compiler sees NUM_CURRENCY_PAIRS in the code it simple substitues the number 5 for the word NUM_CURRENCY_PAIR.
//   Sometimes, but not in this case we dont know how many elements we want to store in an array. For example let us say we declare an array for WinningTrades.
//   Then we might typically declare an empty array using  WinningTrades[] and use functions like ArrayResize() and ArraySize() to work with this DYNAMIC ARRAY.


// #4# Question Tim: Why don't we assign the constants to the words with '='? How can we use this in the future?
// A. A constant is not a variable. A Constant cannot be changed by the program. A Variable can. Using Constants for values that dont need to be changed by the program
//    is safer. The programmer of course can change this value at any time and this value will then be reflected throughout the program. It is much easier and less prone
//    to error than hunting through the program, trying to look for and change individual numbers.



                                       //---------------------------------------------------------------+
                                       //                                                               |
                                       //     Archive:   Useful Tips by Tim                             |
                                       //                                                               |
                                       //---------------------------------------------------------------+                                               
   
    // I'm sorry but MT4 and most other languages wont support this sort of logic
    // You have to use logic like
    //   emasUp =  ema7 > ema14   &&  ema14 > sma50;     
    
   // void EntryRules()  //***  I changed the entry rules  from void - meaning nothing is returned by the function to int - meaning 
                      //***  the function returns an integer value.
                      //***  We want this function to return one of three possible values -  NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY
                      //***  These return values have been declared as manifest constants at the top of the program. 
                      //**** These constant declarations are global which means that they can be used anywhere in the program.
   
    
                                                
  //*** No it is better to put them in the entry rules function where they are needed. I have moved them there  
//   ema7=iMA(symbol,PERIOD_M5,0,MODE_EMA,Close,0);
//   ema14=iMA(symbol,PERIOD_M5,0,MODE_EMA,Close,0);
//   sma50=iMA(symbol,Period_M5,0,MODE_SMA,Close,0);
  //#3#***Question Tim: Can we hit 2 stones with 1 bullet, declare and assign at the same time, eg: 'double botfilters=BotFilters[c]'
     
     // A. Yes you can do this and people will argue constantly about what is "best practice".  In my opinon  it is usually better to declare the variables at the top of a function
     //    or in a global block as the case may be and then assign values latter.
     //    My underlying philosophy is that you should always make it easy for the other guy to be able to read or debug your code even if it requires a bit more typing.
     //    Writing crypyic code is not clever and it leads to endless frustration for others who may need to modify or maintain your code after you have finished with it
     //    Cryptic code can also bite you in the bum when you revisit a piece of code that you wrote some time ago and can't figure out what you did or why you did it.

  
  
  // int count = ArraySize(CurrencyPair);                     //I'm not sure if this goes here or if it is a local?
                                                   // The variable count here is local to the init function.
                                                   // We would have to declare count as a global variable if we wanted to reference it from elsewhere in the program
                                                   // We could then call the ArraySize function here to correctly initialise the count variable
                                                   // As I think you are starting to realise, it is much simpler to just declare fixed (static) arrays 
                                                   // using a manifest constant to define their size.
                                                   // We can do this in this case becuase we already know that the array will hold 5 element 
   
 
  // The following won't work because we are trying to assign VARIABLE values. When we compile our code the program has no idea what values the
  // user is going to place in these variables
                                                                                                                                           
  // double TopFilters[]   = {EUR_USD_TopFilter_Ok, GBP_USD_TopFilter_Ok,USD_JPY_TopFilter_Ok,USD_CHF_TopFilter_Ok,AUD_USD_TopFilter_Ok};
  // double BotFilters[]   = {EUR_USD_BotFilter_Ok,GBP_USD_BotFilter_Ok,USD_JPY_BotFilter_Ok,USD_CHF_BotFilter_Ok,AUD_USD_BotFilter_Ok};
  // bool Buy_Flags[]    = {EUR_USD_BuyFlag,GBP_USD_BuyFlag,USD_JPY_BuyFlag,USD_CHF_BuyFlag,AUD_USD_BuyFlag};
  // bool Sell_Flags[]   = {EUR_USD_SellFlag,GBP_USD_SellFlag,USD_JPY_SellFlag,USD_CHF_SellFlag,AUD_USD_SellFlag};
                                                   
 
    
   //string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"};  // Ths works OK for the CurrencyPair array because we are assigning
                                                                            // CONSTANT string values. by this tim meant [1] &, we need to build an array
                                                 
                                                //Alternatively we could just use a fixed 5 
                                                //***   slot array and use a manifest constant to define it.
                                                //****  As it is not going to change in size a dynamic array is really overkill in this situation.
                                                //****  At the moment we are reinitializing the array every tick and this uses up unnecessary 
                                                //****  computer power. Too much inefficient coding can result in a slow running program which becomes 
                                                //****  particularly noticable when running optimizations. This is something that you must keep in
                                                //****  mind when writing larger or more complex programs.
                                        
//*** The following line has been moved down a few lines to the global parameters area
   //*** This was done because it is not an external parameter. I'm just trying to keep things "neat and tidy :)"   
   //  string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"}; //***Global Declaration of Array 'Pair' so we can call it in 'start' function
   //TIP FOR Me: Variables declared here (ie outside of start function
   //will preserve their value with each tick (hence we can't declare ema's here, etc. 
   //they are called Global variables, local variables are within functions

//*** Try to use local variables as much as possible as it keeps the program more modularised and helps prevent bugs**understood**
                        //*** Notice that I have started these local variable names with lower case letters. 
                        //*** This makes them more easily recognizable as local variables as compared to global variables whose names I start 
                        //*** with Upper Case letters. **got it**  
                        //*** These items i.e. symbol and entrystatus, are called local variables. They are only valid inside the function in which 
                        
                        
                                                //****  This will work but this array sizing only needs to be done once when the program starts up.
                                                //****  It is therefore better to place the array sizing into the init function and use it to set a
                                                //****  global parameter that we could call NumCurrencyPairs. 
                                       
   
                                                //After this I don't know how to use this, i guess we substitute OrderSend(Symbol)
                                                //part with the array name so it loops through that. is that so?        
                                              
    // *** Yes that is so and a bit more.  
    //*** I have added some curly brackets to the entire block so that the FOR LOOP now applies to the whole block i.e everything inside the curly brackets.    
    
      //*** TODO
        //*** First we will need to handle the top amd bottom filter levels for the  currency pairs
        //*** There is a number of ways of going about this. Perhaps the most straightforward is to use some more arrays and initialize them 
        //*** in the init function with the external parameter values. make sure you keep them all in the same order as the currency pair arrays   
        //*** and note that the first element in the array is [0] not [1]
        //*** You may as well set up the buy/sell flags in the same way while you are at it.


    // TODO 22 Jun 09
    // Set up the rest of the arrays as shown in the init function  ***Done
    // Complete the coding of the  EntryRules function noting how calling parameters are defined and used
    // in the start (main) function, 
    
   
    // TODO 23 Jun 09 
    // put the call to the entry rules function inside the currency loop and pass it some parameters as shown/described
    // Compile the code and then use the strategy tester, log files and debug statements to test what we have done so far
    // you should be able to see the Long, Short  &  No_entry signals in the log file.

